#!/usr/bin/env python
# -*- coding: utf-8 -*-

# GIMP plugin to shrink/grow the selection (assign to a shortcut)

# (c) Ofnuts 2021
#
#   History:
#
#   v0.0: 2021-04-16 First published version
#   v0.1: 2021-04-16 Code optimization (golf, anyone?)

#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published
#   by the Free Software Foundation; either version 3 of the License, or
#   (at your option) any later version.
#
#   This very file is the complete source code to the program.
#
#   If you make and redistribute changes to this code, please mark it
#   in reasonable ways as different from the original version. 
#   
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   The GPL v3 licence is available at: https://www.gnu.org/licenses/gpl-3.0.en.html

import sys,os,os.path,traceback
from gimpfu import *

### Registrations
author='Ofnuts'
year='2021'
genericDesc='%s selection by one pixel'
whoiam='\n'+os.path.abspath(sys.argv[0])

def regentry(verb,desc):
    register(
        'ofn-select-%s'% verb,genericDesc % desc,(genericDesc+whoiam) % desc,
        author,author,year,desc+'...','*',
        [ (PF_IMAGE, 'image', 'Input image', None),],[],
        lambda image: pdb['gimp_selection_'+verb](image,1),  # function is simple enough to be a lambda
        menu='<Image>/Select/Grow-Shrink'
    )
    
regentry('shrink','Shrink')
regentry('grow','Grow')
main()
